// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <windows.h>

typedef void(__stdcall* mymethod_net5_proc)(intptr_t text);
typedef void(__stdcall* mymethod_netstd11_proc)(intptr_t text);

static void* load_library(const char* path)
{
    HMODULE h = LoadLibraryA(path);
    return (void*)h;
}

static void* get_export(void* h, const char* name)
{
    void* f = GetProcAddress((HMODULE)h, name);
    return f;
}

int main()
{
    std::cout << "Hello World!\n";

    const wchar_t* pText = L"Hello World";

    {
        void* mod = load_library("ClassLibrary3.dll");
        mymethod_net5_proc mymethod_net5 = (mymethod_net5_proc)get_export(mod, "mymethod_net5");
        mymethod_net5((intptr_t)pText);
    }

    {
        void* mod = load_library("ClassLibrary2.dll");
        mymethod_netstd11_proc mymethod_netstd11= (mymethod_netstd11_proc)get_export(mod, "mymethod_netstd1_1");
        mymethod_netstd11((intptr_t)pText);
    }
}
